// Code generated by bpf2go; DO NOT EDIT.
//go:build 386 || amd64

package main

import (
	"bytes"
	_ "embed"
	"fmt"
	"io"

	"github.com/cilium/ebpf"
)

type KProbePWRUEventT struct {
	Pid        uint32
	Type       uint32
	Addr       uint64
	SkbAddr    uint64
	Ts         uint64
	PrintSkbId uint64
	Meta       struct {
		Netns    uint32
		Mark     uint32
		Ifindex  uint32
		Len      uint32
		Mtu      uint32
		Protocol uint16
		Pad      uint16
	}
	Tuple struct {
		Saddr struct {
			V4addr uint32
			_      [12]byte
		}
		Daddr struct {
			V4addr uint32
			_      [12]byte
		}
		Sport   uint16
		Dport   uint16
		L3Proto uint16
		L4Proto uint8
		Pad     uint8
	}
	PrintStackId int64
	ParamSecond  uint64
	CpuId        uint32
}

type KProbePWRUPrintSkbValue struct {
	Len uint32
	Str [2048]int8
}

// LoadKProbePWRU returns the embedded CollectionSpec for KProbePWRU.
func LoadKProbePWRU() (*ebpf.CollectionSpec, error) {
	reader := bytes.NewReader(_KProbePWRUBytes)
	spec, err := ebpf.LoadCollectionSpecFromReader(reader)
	if err != nil {
		return nil, fmt.Errorf("can't load KProbePWRU: %w", err)
	}

	return spec, err
}

// LoadKProbePWRUObjects loads KProbePWRU and converts it into a struct.
//
// The following types are suitable as obj argument:
//
//	*KProbePWRUObjects
//	*KProbePWRUPrograms
//	*KProbePWRUMaps
//
// See ebpf.CollectionSpec.LoadAndAssign documentation for details.
func LoadKProbePWRUObjects(obj interface{}, opts *ebpf.CollectionOptions) error {
	spec, err := LoadKProbePWRU()
	if err != nil {
		return err
	}

	return spec.LoadAndAssign(obj, opts)
}

// KProbePWRUSpecs contains maps and programs before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type KProbePWRUSpecs struct {
	KProbePWRUProgramSpecs
	KProbePWRUMapSpecs
}

// KProbePWRUSpecs contains programs before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type KProbePWRUProgramSpecs struct {
	FentryTc                     *ebpf.ProgramSpec `ebpf:"fentry_tc"`
	FexitSkbClone                *ebpf.ProgramSpec `ebpf:"fexit_skb_clone"`
	FexitSkbCopy                 *ebpf.ProgramSpec `ebpf:"fexit_skb_copy"`
	KprobeSkb1                   *ebpf.ProgramSpec `ebpf:"kprobe_skb_1"`
	KprobeSkb2                   *ebpf.ProgramSpec `ebpf:"kprobe_skb_2"`
	KprobeSkb3                   *ebpf.ProgramSpec `ebpf:"kprobe_skb_3"`
	KprobeSkb4                   *ebpf.ProgramSpec `ebpf:"kprobe_skb_4"`
	KprobeSkb5                   *ebpf.ProgramSpec `ebpf:"kprobe_skb_5"`
	KprobeSkbByStackid           *ebpf.ProgramSpec `ebpf:"kprobe_skb_by_stackid"`
	KprobeSkbLifetimeTermination *ebpf.ProgramSpec `ebpf:"kprobe_skb_lifetime_termination"`
}

// KProbePWRUMapSpecs contains maps before they are loaded into the kernel.
//
// It can be passed ebpf.CollectionSpec.Assign.
type KProbePWRUMapSpecs struct {
	Events        *ebpf.MapSpec `ebpf:"events"`
	PrintSkbMap   *ebpf.MapSpec `ebpf:"print_skb_map"`
	PrintStackMap *ebpf.MapSpec `ebpf:"print_stack_map"`
	SkbAddresses  *ebpf.MapSpec `ebpf:"skb_addresses"`
	SkbStackid    *ebpf.MapSpec `ebpf:"skb_stackid"`
	StackidSkb    *ebpf.MapSpec `ebpf:"stackid_skb"`
}

// KProbePWRUObjects contains all objects after they have been loaded into the kernel.
//
// It can be passed to LoadKProbePWRUObjects or ebpf.CollectionSpec.LoadAndAssign.
type KProbePWRUObjects struct {
	KProbePWRUPrograms
	KProbePWRUMaps
}

func (o *KProbePWRUObjects) Close() error {
	return _KProbePWRUClose(
		&o.KProbePWRUPrograms,
		&o.KProbePWRUMaps,
	)
}

// KProbePWRUMaps contains all maps after they have been loaded into the kernel.
//
// It can be passed to LoadKProbePWRUObjects or ebpf.CollectionSpec.LoadAndAssign.
type KProbePWRUMaps struct {
	Events        *ebpf.Map `ebpf:"events"`
	PrintSkbMap   *ebpf.Map `ebpf:"print_skb_map"`
	PrintStackMap *ebpf.Map `ebpf:"print_stack_map"`
	SkbAddresses  *ebpf.Map `ebpf:"skb_addresses"`
	SkbStackid    *ebpf.Map `ebpf:"skb_stackid"`
	StackidSkb    *ebpf.Map `ebpf:"stackid_skb"`
}

func (m *KProbePWRUMaps) Close() error {
	return _KProbePWRUClose(
		m.Events,
		m.PrintSkbMap,
		m.PrintStackMap,
		m.SkbAddresses,
		m.SkbStackid,
		m.StackidSkb,
	)
}

// KProbePWRUPrograms contains all programs after they have been loaded into the kernel.
//
// It can be passed to LoadKProbePWRUObjects or ebpf.CollectionSpec.LoadAndAssign.
type KProbePWRUPrograms struct {
	FentryTc                     *ebpf.Program `ebpf:"fentry_tc"`
	FexitSkbClone                *ebpf.Program `ebpf:"fexit_skb_clone"`
	FexitSkbCopy                 *ebpf.Program `ebpf:"fexit_skb_copy"`
	KprobeSkb1                   *ebpf.Program `ebpf:"kprobe_skb_1"`
	KprobeSkb2                   *ebpf.Program `ebpf:"kprobe_skb_2"`
	KprobeSkb3                   *ebpf.Program `ebpf:"kprobe_skb_3"`
	KprobeSkb4                   *ebpf.Program `ebpf:"kprobe_skb_4"`
	KprobeSkb5                   *ebpf.Program `ebpf:"kprobe_skb_5"`
	KprobeSkbByStackid           *ebpf.Program `ebpf:"kprobe_skb_by_stackid"`
	KprobeSkbLifetimeTermination *ebpf.Program `ebpf:"kprobe_skb_lifetime_termination"`
}

func (p *KProbePWRUPrograms) Close() error {
	return _KProbePWRUClose(
		p.FentryTc,
		p.FexitSkbClone,
		p.FexitSkbCopy,
		p.KprobeSkb1,
		p.KprobeSkb2,
		p.KprobeSkb3,
		p.KprobeSkb4,
		p.KprobeSkb5,
		p.KprobeSkbByStackid,
		p.KprobeSkbLifetimeTermination,
	)
}

func _KProbePWRUClose(closers ...io.Closer) error {
	for _, closer := range closers {
		if err := closer.Close(); err != nil {
			return err
		}
	}
	return nil
}

// Do not access this directly.
//
//go:embed kprobepwru_x86_bpfel.o
var _KProbePWRUBytes []byte
